/*
**	Apple Macintosh Developer Technical Support
**
**	Header for routines demonstrating how to read resource files without
**	using the Resource Manager.
**
**	by Mark Cookson, Apple Developer Technical Support
**
**	File:	ReadResource.h
**
**	Copyright 1996 Apple Computer, Inc.
**	All rights reserved.
**
**	You may incorporate this sample code into your applications without
**	restriction, though the sample code has been provided "AS IS" and the
**	responsibility for its operation is 100% yours.  However, what you are
**	not permitted to do is to redistribute the source as "Apple Sample
**	Code" after having made changes. If you're going to re-distribute the
**	source, we require that you make it clear in the source that the code
**	was descended from Apple Sample Code, but that you've made changes.
*/

#ifndef __READRESOURCE__
#define __READRESOURCE__

#include <Errors.h>
#include <Resources.h>

#ifndef __DEFINES__
#include "Defines.h"
#endif

struct ResourceHeader {
	long			resDataOffset;
	long			resMapOffset;
	long			resDataLength;
	long			resMapLength;
};
typedef struct ResourceHeader ResourceHeader;

struct ResourceMap {
	unsigned char	reserved1[16];
	long			reserved2;
	short			reserved3;
	short			resFileAttrs;
	unsigned short	typesListOffset;
	unsigned short	namesListOffset;
	unsigned short	numTypesInMap;
};
typedef struct ResourceMap ResourceMap;

struct ResourceTypeListEntry {
	OSType			resType;
	unsigned short	numEntries;
	unsigned short	referenceOffset;
};
typedef struct ResourceTypeListEntry ResourceTypeListEntry;

struct ResReference {
	short			ID;
	unsigned short	nameOffset;
	long			dataOffset;
	long			reserved;
};
typedef struct ResReference ResReference;

		OSErr	MyGetFirstResource		(short refNum,
										OSType targetType,
										short *targetID);

		OSErr	MyGetResourcePosition	(short refNum,
										OSType targetType,
										short targetID,
										long *firstByte);
		
		OSErr	MyGetTypesPosition		(short refNum,
										OSType theType,
										short *numResources,
										long *dataOffset,
										long *firstByteOfTypeList);

#endif